function connected_matrix(Nx, Ny)
  M = zeros(Int64, Nx, Ny)

  NN = length(M)
  ix, iy = 1, 1
  ix_dir = 1
  n = 1
  while n <= NN
    M[ix,iy] = n
    n += 1

    if ix_dir > 0
      if ix < Nx
        ix += 1
      else
        iy += 1
        ix_dir *= -1
      end
    else
      if ix > 1
        ix -= 1
      else
        iy += 1
        ix_dir *= -1
      end
    end
  end
  
  return M
end


function connected_matrix(Nx, Ny, Nz)
  M = zeros(Int64, Nx, Ny, Nz)
  ijks = NTuple{3,Int64}[]

  NN = length(M)
  ix, iy, iz = 1, 1, 1
  ix_dir, iy_dir = 1, 1
  n = 1
  while n <= NN
    M[ix,iy,iz] = n
    push!(ijks, (ix,iy,iz))
    n += 1

    if ix_dir > 0
      if ix < Nx
        ix += 1
      else
        if iy_dir > 0
          if iy < Ny
            iy += 1
          else
            iz += 1
            iy_dir *= -1
          end
        else
          if iy > 1
            iy -= 1
          else
            iz += 1
            iy_dir *= -1
          end
        end
        ix_dir *= -1
      end
    else
      if ix > 1
        ix -= 1
      else
        if iy_dir > 0
          if iy < Ny
            iy += 1
          else
            iz += 1
            iy_dir *= -1
          end
        else
          if iy > 1
            iy -= 1
          else
            iz += 1
            iy_dir *= -1
          end
        end
        ix_dir *= -1
      end
    end

  end
  
  return M, ijks
end

M2d = connected_matrix(10, 10)
display(M2d)
M3d, ijks = connected_matrix(4,4,4)
display(ijks)
# display(M3d)
# for mijk in M3d
#   println(mijk)
# end
